/*
 * This software is copyright 1992 by Robert Morris.
 * You may freely redistribute this software as shareware
 * if you do so in the same form as you got it. If you find
 * this software useful, please send $12 to:
 *   Robert Morris
 *   P.O. Box 1044
 *   Harvard Square Station
 *   Cambridge, MA 02238
 *   ecognome@aol.com
 * If you incorporate any of this software in any kind of
 * commercial product, please send $2 per copy distributed
 * to the above address.
 */
 

int
HasQD32()
{
	if(HasColorQD() == 0)
		return(0);
#define QD32Trap 0xAB03
#define UnImplTrap 0xA89F
	if(NGetTrapAddress(QD32Trap, ToolTrap) == NGetTrapAddress(UnImplTrap, ToolTrap))
		return(0);
	return(1);
}

int
HasColorQD()
{
	SysEnvRec se;
	int err;
	
	err = SysEnvirons(1, &se);
	if(err != 0)
		return(0);
	if(se.hasColorQD == TRUE)
		return(1);
	return(0);
}

int
HasSystem7()
{
	SysEnvRec se;
	
	if(SysEnvirons(1, &se) < 0)
		return(0);
	else
		return(se.systemVersion >= 0x0700);
}
