/*
 * This software is copyright 1992 by Robert Morris.
 * You may freely redistribute this software as shareware
 * if you do so in the same form as you got it. If you find
 * this software useful, please send $12 to:
 *   Robert Morris
 *   P.O. Box 1044
 *   Harvard Square Station
 *   Cambridge, MA 02238
 *   ecognome@aol.com
 * If you incorporate any of this software in any kind of
 * commercial product, please send $2 per copy distributed
 * to the above address.
 */
 
/*
 * an interface for using TIFF files with QuickDraw.
 */
 
#include "tiff.h"
 
/*
 * record of relevant information gained by scanning the TIFF fields.
 */
struct TIFFInfo{
	short ref; /* Mac file reference */
	short byteOrder; /* LittleEndian or BigEndian */
	long offset; /* of this Image File Directory */
	long nextOffset; /* of next Image File Directory */
	OSErr err;
	Str255 errStr;
	
	long *bitsPerSample; /* [samplesPerPixel] */
	CTabHandle colorMap;
	long compression;
	long predictor;
	long imageLength;
	long imageWidth;
	long photometricInterpretation;
	long planarConfiguration;
	long rowsPerStrip;
	long samplesPerPixel;
	long *stripByteCounts;
	long stripsPerImage;
	long *stripOffsets; /* [# of strips] */
	long t6Options;
	long fillOrder;
};
typedef struct TIFFInfo *TIFFPtr;

TIFFPtr ScanTIFF(int ref);
void DisposeTIFF(TIFFPtr);
OSErr DrawTIFF(int ref, TIFFPtr ti, Rect sr, Rect dr, int dither);
OSErr GetTIFFError(TIFFPtr, StringPtr);
int UnLZW(char *in, long inlen, char *out, long outlen);
OSErr DecodeT6(TIFFPtr, char *in, long inlen, char *out, long outlen);
Boolean TIFFDrawable();